/*
*
* poly.h -- defines for the Polyphonic Music functions
*
****************/

#define CNAT_L1 212  /* notes 1 octave below middle C octave */
#define CSHA_L1 225
#define DNAT_L1 238
#define DSHA_L1 252
#define ENAT_L1 267
#define FNAT_L1 283
#define FSHA_L1 300
#define GNAT_L1 318
#define GSHA_L1 337
#define ANAT_L1 357
#define ASHA_L1 378
#define BNAT_L1 400

/* note values of octave which contains middle C */
#define CNAT_M 390 
#define CSHA_M 413
#define DNAT_M 438
#define DSHA_M 462
#define ENAT_M 490
#define ESHA_M 519
#define FNAT_M 519
#define FSHA_M 550
#define GNAT_M 583
#define GSHA_M 618
#define ANAT_M 655
#define ASHA_M 694
#define BNAT_M 736
#define BSHA_M 779

/*#define CNAT_M 602   these higher values may be useful for slower PC's
#define CSHA_M 640
#define DNAT_M 679
#define DSHA_M 716
#define ENAT_M 762
#define ESHA_M 806
#define FNAT_M 806
#define FSHA_M 856
#define GNAT_M 906
#define GSHA_M 960 
#define ANAT_M 1017
#define ASHA_M 1074
#define BNAT_M 1140
#define BSHA_M 1140*/

#define CNAT_H1 848   /* the octave above the octave containing middle C */
#define CSHA_H1 900
#define DNAT_H1 954
#define DSHA_H1 1010
#define ENAT_H1 1070
#define FNAT_H1 1132
#define FSHA_H1 1200
#define GNAT_H1 1272
#define GSHA_H1 1348
#define ANAT_H1 1428
#define ASHA_H1 1512
#define BNAT_H1 1600

/* defines for voice, tempo, values, etc. */

#define TCHANGE	16384   /* constant values to use in poly() and tritone() */
#define V1	32768
#define V2 	40960
#define V3	49152
#define V4  	53744   /* note: this is only in prototype stages, poly() will interpret as V3 */
#define DUR	8192
#define KBCHECK 24576
#define STOP	0

/* function definitions: */

int playpoly(char *, int);
int looppoly(char *, int);

unsigned processval( int, int );
unsigned polytempo( int, int );
unsigned timetest( int );

void poly( int * );
void tritone( int, int, int, int, int );
