/*
*
*  TimeChk.c -- a program to return the amount of time elapsed
*               during several processesor-intensive routines
*               and to return the value of the appropriate polyphonic
*               music-playing tempo. (see POLY.DOC for details)
*
************************/
#include <poly.h>

#define  DEFAULT  250

main(int argc, char *argv[])
{
   int t, n;
   unsigned p;

   t = ( argc > 1? atoi(argv[1]) : 10 );      /* allows test input from command line */
   n = ( argc > 2? atoi(argv[2]) : DEFAULT );
   puts("Determining speed of processor... Please wait...");
   printf("\nProcess speed for %d tests of %d nodes is: %d", t, n, p = processval(t,n));
   printf("\nApproximate Polyphonic tempo speed for this computer = %u", polytempo(t,n));
   /* note: polytempo was tailored to work only with the test values of
   	    times = 10, nodes = 250 (later versions may be different) */
}
